/* slots.c
 * Slots.
 *
 * Copyright (c) 1996 Systems Architecture Research Centre,
 *		   City University, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@sarc.city.ac.uk>, June 1996.
 */

#include "gtypes.h"
#include "slots.h"
#include "registers.h"
#include "md.h"

slots slotinfo[MAXSLOT+MAXRETURNS];
slots* returninfo = &slotinfo[MAXSLOT];

slots* localinfo;
slots* stackinfo;
slots* tempinfo;

extern int maxLocal;


/*
 * Initiate slots.
 */
void
initSlots(void)
{
	int i;

	localinfo = &slotinfo[0];

        /* Free all slots */
        for (i = 0; i < MAXSLOT; i++) {
                slotinfo[i].regno = NOREG;
                slotinfo[i].type = Tnull;
                slotinfo[i].write = 0;
		slotinfo[i].modified = 0;
        }
        /* Mark returns as busy */
        for (i = 0; i < MAXRETURNS; i++) {
                returninfo[i].regno = NOREG;
                returninfo[i].type = Tnull;
                returninfo[i].write = 1;
		returninfo[i].modified = 0;
        }

        /* Mark all locals as busy */
        for (i = 0; i < maxLocal; i++) {
                localinfo[i].write = 1;
		localinfo[i].modified = 0;
        }

        returninfo[returnInt].regno = 0;	/* eax */
        returninfo[returnRef].regno = 0;	/* eax */
        returninfo[returnLong].regno = 0;	/* eax */
        returninfo[returnLong+1].regno = 2;	/* edx */
        returninfo[returnFloat].regno = 8;	/* flt */
        returninfo[returnDouble].regno = 9;	/* dbl */
        returninfo[returnDouble+1].regno = 0;	/*  "  */
}
